/*
PRICE was written by Graham Ruby.
This file is part of PRICE.

PRICE is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PRICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PRICE.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef READFILE_CPP
#define READFILE_CPP

#include "ReadFile.h"
#include "AssemblyException.h"

ReadFile::~ReadFile(){}

// static method
char* ReadFile::interpretString(char* rawSeq, long rawLen, set<char>* okToSkip){
  char* newSeqExtra = new char[rawLen];
  long n2 = 0;
  for (long n = 0; n < rawLen; ++n){
    n2++;
    switch(rawSeq[n]) {
    // allowed nucleotide characters
    case 'A': newSeqExtra[n2-1] = 'A'; break;
    case 'C': newSeqExtra[n2-1] = 'C'; break;
    case 'G': newSeqExtra[n2-1] = 'G'; break;
    case 'T': newSeqExtra[n2-1] = 'T'; break;
    case 'U': newSeqExtra[n2-1] = 'T'; break;
    case 'R': newSeqExtra[n2-1] = 'N'; break;
    case 'Y': newSeqExtra[n2-1] = 'N'; break;
    case 'S': newSeqExtra[n2-1] = 'N'; break;
    case 'W': newSeqExtra[n2-1] = 'N'; break;
    case 'K': newSeqExtra[n2-1] = 'N'; break;
    case 'M': newSeqExtra[n2-1] = 'N'; break;
    case 'B': newSeqExtra[n2-1] = 'N'; break;
    case 'D': newSeqExtra[n2-1] = 'N'; break;
    case 'H': newSeqExtra[n2-1] = 'N'; break;
    case 'V': newSeqExtra[n2-1] = 'N'; break;
    case 'N': newSeqExtra[n2-1] = 'N'; break;
    case 'a': newSeqExtra[n2-1] = 'A'; break;
    case 'c': newSeqExtra[n2-1] = 'C'; break;
    case 'g': newSeqExtra[n2-1] = 'G'; break;
    case 't': newSeqExtra[n2-1] = 'T'; break;
    case 'u': newSeqExtra[n2-1] = 'T'; break;
    case 'r': newSeqExtra[n2-1] = 'N'; break;
    case 'y': newSeqExtra[n2-1] = 'N'; break;
    case 's': newSeqExtra[n2-1] = 'N'; break;
    case 'w': newSeqExtra[n2-1] = 'N'; break;
    case 'k': newSeqExtra[n2-1] = 'N'; break;
    case 'm': newSeqExtra[n2-1] = 'N'; break;
    case 'b': newSeqExtra[n2-1] = 'N'; break;
    case 'd': newSeqExtra[n2-1] = 'N'; break;
    case 'h': newSeqExtra[n2-1] = 'N'; break;
    case 'v': newSeqExtra[n2-1] = 'N'; break;
    case 'n': newSeqExtra[n2-1] = 'N'; break;
    case '.': newSeqExtra[n2-1] = 'N'; break;
    default:
      if (okToSkip->count(rawSeq[n]) == 0){
	throw AssemblyException::ArgError("nucleotide seq contains invalid char");
      } else { n2--; }
    // no default; any other letter is skipped
    }
  }
  char* newSeqExtra2 = new char[n2+1];
  for (long n = 0; n < n2; ++n){ newSeqExtra2[n] = newSeqExtra[n]; }
  newSeqExtra2[n2] = '\0';
  delete [] newSeqExtra;
  return newSeqExtra2;
}



#endif
